"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es6.regexp.to-string");

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/es6.promise");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.keys");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.object.assign");

require("isomorphic-fetch");

var _qs = _interopRequireDefault(require("qs"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var mimeLib = {
  json: 'application/json',
  form: 'multipart/form-data',
  html: 'text/html',
  xml: 'application/xml',
  text: 'text/plain'
};

var Hifetch =
/*#__PURE__*/
function () {
  function Hifetch(opt) {
    _classCallCheck(this, Hifetch);

    this._config = Object.assign({}, Hifetch.defaultConfig, opt);
    var _this$_config = this._config,
        query = _this$_config.query,
        method = _this$_config.method,
        responseType = _this$_config.responseType,
        data = _this$_config.data,
        originDataType = _this$_config.dataType,
        FormData = _this$_config.FormData,
        headers = _this$_config.headers,
        jwtToken = _this$_config.jwtToken,
        enableCookies = _this$_config.enableCookies,
        disableCORS = _this$_config.disableCORS;
    this._queryString = query ? _qs.default.stringify(query) : '';
    var fetchOpt = {};
    this._fetchOpt = fetchOpt;

    if (!disableCORS) {
      fetchOpt.mode = 'cors';
    }

    if (enableCookies) {
      fetchOpt.credentials = disableCORS ? 'same-origin' : 'include';
    }

    var moreHeaders = {
      Accept: /\//.test(responseType) ? responseType : mimeLib[responseType]
    };

    if (jwtToken) {
      moreHeaders.Authorization = "Bearer ".concat(jwtToken);
    }

    var dataType;
    var dataForBody = data;

    var mergeToForm = function mergeToForm(dict) {
      Object.keys(dict).forEach(function (key) {
        dataForBody.append(key, dict[key]);
      });
    };

    if (data) {
      dataType = (/\//.test(originDataType) ? originDataType : mimeLib[originDataType]) || Hifetch.defaultConfig.dataType;

      if (_typeof(data) === 'object') {
        if (FormData && data instanceof FormData) {
          dataType = mimeLib.form;
        } else if (dataType === mimeLib.form) {
          dataForBody = new FormData();
          mergeToForm(data);
        } else if (dataType === Hifetch.defaultConfig.dataType) {
          dataForBody = _qs.default.stringify(data);
        } else if (dataType.indexOf('json') !== -1) {
          dataForBody = JSON.stringify(data);
        }
      }
    }

    Object.assign(fetchOpt, {
      method: method.toUpperCase(),
      headers: Object.assign({}, headers, moreHeaders, !dataType || dataType === mimeLib.form ? {// leave Content-Type' field empty, Fetch APi will automatically create:
        // Content-Type: multipart/form-data; boundary=----WebKitFormBoundaryyEmKNDsBKjB7QEqu
      } : {
        'Content-Type': dataType
      })
    }, data ? {
      body: dataForBody
    } : {});
  }

  _createClass(Hifetch, [{
    key: "send",
    value: function send() {
      var _this = this;

      var _this$_config2 = this._config,
          url = _this$_config2.url,
          timeout = _this$_config2.timeout,
          validateStatus = _this$_config2.validateStatus,
          disableStatusValidator = _this$_config2.disableStatusValidator,
          mergeHeaders = _this$_config2.mergeHeaders,
          filterHeaders = _this$_config2.filterHeaders,
          disableResponseStyle = _this$_config2.disableResponseStyle,
          responseStyle = _this$_config2.responseStyle,
          enableMeta = _this$_config2.enableMeta,
          enableResponseObject = _this$_config2.enableResponseObject,
          parser = _this$_config2.parser,
          handler = _this$_config2.handler,
          success = _this$_config2.success,
          error = _this$_config2.error;
      var current = uuid();
      this._current = current;

      var _filterHeaders;

      if (filterHeaders) {
        _filterHeaders = {};

        for (var header in filterHeaders) {
          _filterHeaders[header.toLowerCase()] = filterHeaders[header];
        }
      }

      return new Promise(function (resolve, reject) {
        if (timeout) {
          setTimeout(function () {
            if (current === _this._current) {
              reject(new Error('TIMEOUT'));
            }
          }, timeout);
        }

        return fetch(_this._queryString ? "".concat(url, "?").concat(_this._queryString) : url, _this._fetchOpt).then(function (res) {
          if (current === _this._current) {
            resolve(res);
          }
        }).catch(function (res) {
          if (current === _this._current) {
            reject(res);
          }
        });
      }).then(function (response) {
        try {
          if (disableStatusValidator || validateStatus(response.status)) {
            return response;
          }
        } catch (e) {
          return error(Object.assign(new Error("[CUSTOM JS ERROR] ".concat(clearErrorMessage(e))), {
            status: 4,
            error: e
          }));
        }

        var err = new Error(response.statusText);
        err.response = response;
        throw err;
      }).then(function (response) {
        var headersForMerge = {};
        Object.keys(mergeHeaders).forEach(function (key) {
          var header = mergeHeaders[key];

          if (header) {
            headersForMerge[key] = response.headers.get(header);
          }
        });

        var withHeaders = function withHeaders(data) {
          var status = response.status,
              statusText = response.statusText,
              resUrl = response.url,
              headers = response.headers;
          var allHeaders = {};
          var headerEntries = [];

          if (headers._headers) {
            headerEntries = Object.keys(headers._headers).map(function (key) {
              return [key, headers._headers[key].join('; ')];
            });
          } else if (headers.entries) {
            headerEntries = headers.entries();
          }

          var _iteratorNormalCompletion = true;
          var _didIteratorError = false;
          var _iteratorError = undefined;

          try {
            for (var _iterator = headerEntries[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
              var i = _step.value;

              if (i && i[0] && (!_filterHeaders || _filterHeaders[i[0]])) {
                allHeaders[i[0]] = i[1];
              }
            }
          } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion && _iterator.return != null) {
                _iterator.return();
              }
            } finally {
              if (_didIteratorError) {
                throw _iteratorError;
              }
            }
          }

          var meta = {
            status: 0,
            httpStatus: status,
            httpStatusText: statusText,
            url: resUrl,
            headers: allHeaders
          };

          if (enableResponseObject) {
            meta.response = response;
          }

          return {
            data: data,
            headersForMerge: headersForMerge,
            meta: meta
          };
        };

        var parsed;

        try {
          parsed = parser(response);
        } catch (err) {
          return error(Object.assign(new Error("[CUSTOM JS ERROR] ".concat(clearErrorMessage(err))), {
            status: 4,
            error: err
          }));
        }

        if (parsed.then) {
          /* eslint-disable promise/no-nesting */
          return parsed.then(withHeaders);
          /* eslint-enable promise/no-nesting */
        }

        return withHeaders(parsed);
      }).then(function (_ref) {
        var data = _ref.data,
            headersForMerge = _ref.headersForMerge,
            meta = _ref.meta;

        try {
          var result = handler(!disableResponseStyle && responseStyle === 'google' && !data.error && data.data || data, headersForMerge, meta);

          if (!disableResponseStyle && _typeof(result) === 'object') {
            if (responseStyle === 'unix' && result.status < 0) {
              return error(Object.assign(new Error("[REMOTE ERROR] status: ".concat(data.status, ", message: ").concat(data.message)), Object.assign({}, meta, {
                status: data.status,
                originMessage: data.message,
                data: result
              })));
            } else if (responseStyle === 'google' && result.error) {
              var _result$error = result.error,
                  code = _result$error.code,
                  _result$error$errors = _result$error.errors,
                  errors = _result$error$errors === void 0 ? [{}] : _result$error$errors;
              var reason = errors[0].reason;
              var originMessage = result.error.message || errors[0].message;
              return error(Object.assign(new Error("[REMOTE ERROR] reason: ".concat(reason, ", code: ").concat(code, ", message: ").concat(originMessage)), Object.assign({}, meta, {
                status: 3,
                code: code,
                originMessage: originMessage,
                reason: reason,
                errors: errors,
                data: result
              })));
            }
          }

          return success(enableResponseObject || enableMeta ? Object.assign({
            data: result
          }, meta) : result);
        } catch (err) {
          return error(Object.assign(new Error("[CUSTOM JS ERROR] ".concat(clearErrorMessage(err))), Object.assign({}, meta, {
            status: 4,
            error: err
          })));
        }
      }).catch(function (err) {
        if (_typeof(err) === 'object' && err.message === 'TIMEOUT') {
          return error(Object.assign(new Error("[TIMEOUT ERROR] limit: ".concat(timeout / 1000, "s")), {
            status: 5,
            timeout: timeout
          }));
        }

        if (err.status) {
          return error(Object.assign(new Error(err.message), err));
        }

        var _ref2 = err.response || {},
            httpStatus = _ref2.status,
            httpStatusText = _ref2.statusText;

        if (httpStatus) {
          return error(Object.assign(new Error("[FETCH ERROR] ".concat(httpStatus, " ").concat(httpStatusText)), {
            status: 2,
            httpStatus: httpStatus,
            httpStatusText: httpStatusText
          }));
        }

        return error(Object.assign(new Error("[INTERNAL JS ERROR] ".concat(clearErrorMessage(err))), {
          status: 1,
          error: err
        }));
      });
    }
  }, {
    key: "cancel",
    value: function cancel() {
      this._current = null;
    }
  }, {
    key: "error",
    value: function error(customError) {
      var error = this._config.error;
      this._current = null;
      return error(Object.assign(new Error("[MANUAL ERROR] ".concat(clearErrorMessage(customError))), {
        status: 6,
        customError: customError
      }));
    }
  }]);

  return Hifetch;
}();

Hifetch.defaultConfig = {
  url: '',
  method: 'get',
  query: null,
  data: '',
  dataType: 'application/x-www-form-urlencoded',
  FormData: typeof window !== 'undefined' ? window.FormData : null,
  jwtToken: '',
  headers: {},
  timeout: 0,
  responseType: 'application/json',
  mergeHeaders: {},
  filterHeaders: null,
  enableCookies: false,
  disableCORS: false,
  disableResponseStyle: false,
  responseStyle: 'google',
  enableMeta: false,
  enableResponseObject: false,
  disableStatusValidator: false,
  validateStatus: function validateStatus(status) {
    return status >= 200 && status < 300;
  },
  parser: function parser(response) {
    return response.json();
  },
  handler: function handler(data, headersForMerge) {
    return typeof data !== 'string' && !Array.isArray(data) ? Object.assign(headersForMerge, data) : data;
  },
  success: function success(res) {
    return res;
  },
  error: function error(res) {
    return Promise.reject(res);
  }
};

function uuid() {
  return new Date().getTime() * 1000 + Math.floor(Math.random() * 1000);
}

function clearErrorMessage(err) {
  return err.toString(); // .replace(/.+:\s*/, '');
}

function hifetch(opt) {
  return new Hifetch(opt);
}

hifetch.Class = Hifetch;
var _default = hifetch;
/* eslint-enable filenames/match-exported */

exports.default = _default;
module.exports = exports.default;