"use strict";

require("core-js/modules/es6.function.name");

var _chai = require("chai");

var _nock = _interopRequireDefault(require("nock"));

var _dist = _interopRequireDefault(require("../dist"));

var _utils = require("./utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint no-unused-expressions: 0 */
describe('delete', function () {
  it('user1', function (done) {
    (0, _nock.default)(_utils.ROOT, {
      reqheaders: {
        'X-My-Headers': '1'
      }
    }).defaultReplyHeaders({
      'X-Powered-By': 'nock'
    }).delete('/user').query({
      uid: 1
    }).reply(200, {
      name: 'user1'
    });
    (0, _dist.default)({
      url: "".concat(_utils.ROOT, "/user"),
      method: 'delete',
      query: {
        uid: 1
      },
      headers: {
        'X-My-Headers': '1'
      },
      mergeHeaders: {
        poweredBy: 'X-Powered-By'
      }
    }).send().then(function (res) {
      (0, _chai.expect)(res.name).to.equal('user1');
      (0, _chai.expect)(res.poweredBy).to.equal('nock');
      done();
    }).catch(function (err) {
      console.log(err);
    });
  });
});