"use strict";

require("core-js/modules/es6.object.assign");

var _chai = require("chai");

var _dist = _interopRequireDefault(require("../dist"));

var _utils = require("./utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint no-unused-expressions: 0 */
describe('error: 1', function () {
  it('promise style', function (done) {
    var fetchConfig = {
      url: "".concat(_utils.ROOT, "/error1")
    };

    var errorHandler = function errorHandler(res) {
      (0, _chai.expect)(res).to.be.an('error');
      (0, _chai.expect)(res.status).to.equal(1);
      (0, _chai.expect)(res.error).to.exist;
    };

    (0, _dist.default)(fetchConfig).send().catch(errorHandler).then(function () {
      done();
    }).catch(function (err) {
      console.log(err);
    });
  });
  it('callback style', function (done) {
    var fetchConfig = {
      url: "".concat(_utils.ROOT, "/error1")
    };

    var errorHandler = function errorHandler(res) {
      (0, _chai.expect)(res).to.be.an('error');
      (0, _chai.expect)(res.status).to.equal(1);
      (0, _chai.expect)(res.error).to.exist;
    };

    (0, _dist.default)(Object.assign({}, fetchConfig, {
      error: errorHandler
    })).send().catch(errorHandler).then(function () {
      done();
    }).catch(function (err) {
      console.log(err);
    });
  });
});