"use strict";

require("core-js/modules/es6.object.assign");

var _chai = require("chai");

var _nock = _interopRequireDefault(require("nock"));

var _dist = _interopRequireDefault(require("../dist"));

var _utils = require("./utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint no-unused-expressions: 0 */
describe('error: 2', function () {
  it('promise style', function (done) {
    (0, _nock.default)(_utils.ROOT).get('/error2').reply(500, {
      status: 0
    });
    var fetchConfig = {
      url: "".concat(_utils.ROOT, "/error2")
    };

    var errorHandler = function errorHandler(res) {
      (0, _chai.expect)(res).to.be.an('error');
      (0, _chai.expect)(res.status).to.equal(2);
      (0, _chai.expect)(res.httpStatus).to.equal(500);
    };

    (0, _dist.default)(fetchConfig).send().catch(errorHandler).then(function () {
      done();
    }).catch(function (err) {
      console.log(err);
    });
  });
  it('callback style', function (done) {
    (0, _nock.default)(_utils.ROOT).get('/error2').reply(500, {
      status: 0
    });
    var fetchConfig = {
      url: "".concat(_utils.ROOT, "/error2")
    };

    var errorHandler = function errorHandler(res) {
      (0, _chai.expect)(res).to.be.an('error');
      (0, _chai.expect)(res.status).to.equal(2);
      (0, _chai.expect)(res.httpStatus).to.equal(500);
    };

    (0, _dist.default)(Object.assign({}, fetchConfig, {
      error: errorHandler
    })).send().then(function () {
      done();
    }).catch(function (err) {
      console.log(err);
    });
  });
});